DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the SelectBox features used.
Backend API
$(() => {
$('#products-simple').dxSelectBox({
items: simpleProducts,
inputAttr: { 'aria-label': 'Simple Product' },
});
$('#products-placeholder').dxSelectBox({
items: simpleProducts,
inputAttr: { 'aria-label': 'Product With Placeholder' },
placeholder: 'Choose Product',
showClearButton: true,
});
$('#products-read-only').dxSelectBox({
items: simpleProducts,
inputAttr: { 'aria-label': 'ReadOnly Product' },
value: simpleProducts[0],
readOnly: true,
});
$('#products-disabled').dxSelectBox({
items: simpleProducts,
inputAttr: { 'aria-label': 'Disabled Product' },
value: simpleProducts[0],
disabled: true,
});
$('#products-data-source').dxSelectBox({
inputAttr: { 'aria-label': 'Product ID' },
dataSource: new DevExpress.data.ArrayStore({
data: products,
key: 'ID',
}),
displayExpr: 'Name',
valueExpr: 'ID',
value: products[0].ID,
});
$('#custom-templates').dxSelectBox({
dataSource: products,
inputAttr: { 'aria-label': 'Templated Product' },
displayExpr: 'Name',
valueExpr: 'ID',
value: products[3].ID,
fieldAddons: {
beforeTemplate: (data) => {
const src = data?.ImageSrc ?? '';
const result = $(`<div class="custom-addon"><img alt="Product name" src="${src}"/></div>`);
return result;
},
},
itemTemplate(data) {
return `<div class='custom-item'><img alt='Product name' src='${
data.ImageSrc}' /><div class='product-name'>${
data.Name}</div></div>`;
},
});
$('#product-handler').dxSelectBox({
items: simpleProducts,
inputAttr: { 'aria-label': 'Product' },
value: simpleProducts[0],
onValueChanged(data) {
$('.current-value > span').text(data.value);
DevExpress.ui.notify(`The value is changed to: "${data.value}"`);
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.3"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="form">
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Default mode</div>
<div class="dx-field-value">
<div id="products-simple"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">With a custom placeholder</div>
<div class="dx-field-value">
<div id="products-placeholder"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Read only</div>
<div class="dx-field-value">
<div id="products-read-only"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Disabled</div>
<div class="dx-field-value">
<div id="products-disabled"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Data source usage</div>
<div class="dx-field-value">
<div id="products-data-source"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Custom templates</div>
<div class="dx-field-value">
<div id="custom-templates"></div>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Event Handling</div>
<div class="dx-field">
<div class="dx-field-label">Product</div>
<div class="dx-field-value">
<div id="product-handler"></div>
</div>
</div>
<div class="current-value"> Selected product is <span>HD Video Player</span> </div>
</div>
</div>
</div>
</body>
</html>
.dx-dropdownlist-popup-wrapper .dx-list:not(.dx-list-select-decorator-enabled) .dx-list-item-content {
padding-left: 7px;
padding-right: 7px;
}
.custom-item {
position: relative;
min-height: 30px;
}
.custom-addon {
padding-left: 8px;
display: flex;
align-items: center;
}
.dx-dropdowneditor-input-wrapper .custom-item > img {
padding-left: 8px;
}
.custom-item .product-name {
display: inline-block;
padding-left: 50px;
text-indent: 0;
line-height: 30px;
font-size: 15px;
width: 100%;
}
.custom-item > img {
left: 1px;
position: absolute;
top: 50%;
margin-top: -15px;
}
.dx-theme-material #custom-templates .dx-texteditor-buttons-container {
display: none;
}
.current-value {
padding: 10px 0;
}
.current-value > span {
font-weight: bold;
}
.dx-theme-material .dx-selectbox-container .product-name {
padding-left: 58px;
}
const simpleProducts = [
'HD Video Player',
'SuperHD Video Player',
'SuperPlasma 50',
'SuperLED 50',
'SuperLED 42',
'SuperLCD 55',
'SuperLCD 42',
'SuperPlasma 65',
'SuperLCD 70',
'Projector Plus',
'Projector PlusHT',
'ExcelRemote IR',
'ExcelRemote BT',
'ExcelRemote IP',
];
const products = [{
ID: 1,
Name: 'HD Video Player',
Price: 330,
Current_Inventory: 225,
Backorder: 0,
Manufacturing: 10,
Category: 'Video Players',
ImageSrc: '../../../../images/products/1-small.png',
}, {
ID: 2,
Name: 'SuperHD Player',
Price: 400,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 25,
Category: 'Video Players',
ImageSrc: '../../../../images/products/2-small.png',
}, {
ID: 3,
Name: 'SuperPlasma 50',
Price: 2400,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/3-small.png',
}, {
ID: 4,
Name: 'SuperLED 50',
Price: 1600,
Current_Inventory: 77,
Backorder: 0,
Manufacturing: 55,
Category: 'Televisions',
ImageSrc: '../../../../images/products/4-small.png',
}, {
ID: 5,
Name: 'SuperLED 42',
Price: 1450,
Current_Inventory: 445,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/5-small.png',
}, {
ID: 6,
Name: 'SuperLCD 55',
Price: 1350,
Current_Inventory: 345,
Backorder: 0,
Manufacturing: 5,
Category: 'Televisions',
ImageSrc: '../../../../images/products/6-small.png',
}, {
ID: 7,
Name: 'SuperLCD 42',
Price: 1200,
Current_Inventory: 210,
Backorder: 0,
Manufacturing: 20,
Category: 'Televisions',
ImageSrc: '../../../../images/products/7-small.png',
}, {
ID: 8,
Name: 'SuperPlasma 65',
Price: 3500,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/8-small.png',
}, {
ID: 9,
Name: 'SuperLCD 70',
Price: 4000,
Current_Inventory: 95,
Backorder: 0,
Manufacturing: 5,
Category: 'Televisions',
ImageSrc: '../../../../images/products/9-small.png',
}, {
ID: 10,
Name: 'DesktopLED 21',
Price: 175,
Current_Inventory: 0,
Backorder: 425,
Manufacturing: 75,
Category: 'Monitors',
ImageSrc: '../../../../images/products/10-small.png',
}, {
ID: 11,
Name: 'DesktopLED 19',
Price: 165,
Current_Inventory: 425,
Backorder: 0,
Manufacturing: 110,
Category: 'Monitors',
ImageSrc: '../../../../images/products/11-small.png',
}, {
ID: 12,
Name: 'DesktopLCD 21',
Price: 170,
Current_Inventory: 210,
Backorder: 0,
Manufacturing: 60,
Category: 'Monitors',
ImageSrc: '../../../../images/products/12-small.png',
}, {
ID: 13,
Name: 'DesktopLCD 19',
Price: 160,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 210,
Category: 'Monitors',
ImageSrc: '../../../../images/products/13-small.png',
}, {
ID: 14,
Name: 'Projector Plus',
Price: 550,
Current_Inventory: 0,
Backorder: 55,
Manufacturing: 10,
Category: 'Projectors',
ImageSrc: '../../../../images/products/14-small.png',
}, {
ID: 15,
Name: 'Projector PlusHD',
Price: 750,
Current_Inventory: 110,
Backorder: 0,
Manufacturing: 90,
Category: 'Projectors',
ImageSrc: '../../../../images/products/15-small.png',
}, {
ID: 16,
Name: 'Projector PlusHT',
Price: 1050,
Current_Inventory: 0,
Backorder: 75,
Manufacturing: 57,
Category: 'Projectors',
ImageSrc: '../../../../images/products/16-small.png',
}, {
ID: 17,
Name: 'ExcelRemote IR',
Price: 150,
Current_Inventory: 650,
Backorder: 0,
Manufacturing: 190,
Category: 'Automation',
ImageSrc: '../../../../images/products/17-small.png',
}, {
ID: 18,
Name: 'ExcelRemote BT',
Price: 180,
Current_Inventory: 310,
Backorder: 0,
Manufacturing: 0,
Category: 'Automation',
ImageSrc: '../../../../images/products/18-small.png',
}, {
ID: 19,
Name: 'ExcelRemote IP',
Price: 200,
Current_Inventory: 0,
Backorder: 325,
Manufacturing: 225,
Category: 'Automation',
ImageSrc: '../../../../images/products/19-small.png',
}];
This demo illustrates the following JavaScript SelectBox properties:
- items
Specifies an array of items displayed in the JavaScript SelectBox. - placeholder
Specifies the text that is displayed when no items are selected. - readOnly
Prevents users from changing the editor's value via the UI. - disabled
Specifies whether the JavaScript SelectBox responds to user interaction. - dataSource
Binds the JavaScript SelectBox to data. Unlike the items property, dataSource accepts the DataSource object that allows users to sort, filter, group, and shape data. - fieldAddons.beforeTemplate and itemTemplate
Allow you to customize the text field and drop-down list items. - onValueChanged event handler
Use this function to perform an action when a user chooses a new value. In this demo, this function is used to display the selected value.
To get started with the DevExtreme JavaScript SelectBox component, refer to the following tutorial for step-by-step instructions: Getting Started with JavaScript SelectBox.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the SelectBox features used.
Backend API
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Default mode</div>
<div class="dx-field-value">
<dx-select-box
[items]="simpleProducts"
[inputAttr]="{ 'aria-label': 'Simple Product' }"
></dx-select-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">With a custom placeholder</div>
<div class="dx-field-value">
<dx-select-box
placeholder="Choose Product"
[items]="simpleProducts"
[inputAttr]="{ 'aria-label': 'Product With Placeholder' }"
[showClearButton]="true"
></dx-select-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Read only</div>
<div class="dx-field-value">
<dx-select-box
[items]="simpleProducts"
[inputAttr]="{ 'aria-label': 'ReadOnly Product' }"
[value]="simpleProducts[0]"
[readOnly]="true"
></dx-select-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Disabled</div>
<div class="dx-field-value">
<dx-select-box
[items]="simpleProducts"
[inputAttr]="{ 'aria-label': 'Disabled Product' }"
[value]="simpleProducts[0]"
[disabled]="true"
></dx-select-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Data source usage</div>
<div class="dx-field-value">
<dx-select-box
displayExpr="Name"
valueExpr="ID"
[dataSource]="data"
[inputAttr]="{ 'aria-label': 'Product ID' }"
[value]="products[0].ID"
></dx-select-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Custom templates</div>
<div class="dx-field-value">
<dx-select-box
id="custom-templates"
displayExpr="Name"
valueExpr="ID"
[dataSource]="products"
[inputAttr]="{ 'aria-label': 'Templated Product' }"
[value]="products[3].ID"
[fieldAddons]="{ beforeTemplate: 'before' }"
>
<div *dxTemplate="let data of 'before'">
<div class="custom-addon">
<img alt="Product name" src="{{ data && data.ImageSrc }}" />
</div>
</div>
<div *dxTemplate="let data of 'item'">
<div class="custom-item">
<img alt="Product name" src="{{ data.ImageSrc }}" />
<div class="product-name">
{{ data.Name }}
</div>
</div>
</div>
</dx-select-box>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Event Handling</div>
<div class="dx-field">
<div class="dx-field-label">Product</div>
<div class="dx-field-value">
<dx-select-box
#selectBox
[items]="simpleProducts"
[inputAttr]="{ 'aria-label': 'Product' }"
[value]="simpleProducts[0]"
(onValueChanged)="onValueChanged($event)"
>
</dx-select-box>
</div>
</div>
<div class="current-value">
Selected product is <span>{{ selectBox.value }}</span>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import notify from 'devextreme/ui/notify';
import { DxSelectBoxModule, DxTextBoxModule } from 'devextreme-angular';
import { ArrayStore } from 'devextreme-angular/common/data';
import { DxSelectBoxTypes } from 'devextreme-angular/ui/select-box';
import { Product, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxSelectBoxModule,
DxTextBoxModule,
],
})
export class AppComponent {
simpleProducts: string[];
products: Product[];
data: ArrayStore;
constructor(service: Service) {
this.products = service.getProducts();
this.simpleProducts = service.getSimpleProducts();
this.data = new ArrayStore({
data: this.products,
key: 'ID',
});
}
onValueChanged({ value }: DxSelectBoxTypes.ValueChangedEvent) {
notify(`The value is changed to: "${value}"`);
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .dx-dropdownlist-popup-wrapper .dx-list:not(.dx-list-select-decorator-enabled) .dx-list-item-content {
padding-left: 7px;
padding-right: 7px;
}
::ng-deep .custom-item {
position: relative;
min-height: 30px;
}
::ng-deep .custom-addon {
padding-left: 8px;
display: flex;
align-items: center;
}
::ng-deep .dx-dropdowneditor-input-wrapper .custom-item > img {
padding-left: 8px;
}
::ng-deep .custom-item .product-name {
display: inline-block;
padding-left: 50px;
text-indent: 0;
line-height: 30px;
font-size: 15px;
width: 100%;
}
::ng-deep .custom-item > img {
left: 1px;
position: absolute;
top: 50%;
margin-top: -15px;
}
::ng-deep .dx-theme-material #custom-templates .dx-texteditor-buttons-container {
display: none;
}
::ng-deep .current-value {
padding: 10px 0;
}
::ng-deep .current-value > span {
font-weight: bold;
}
::ng-deep .dx-theme-material .dx-selectbox-container .product-name {
padding-left: 58px;
}
import { Injectable } from '@angular/core';
export class Product {
ID: number;
Name: string;
Price: number;
Current_Inventory: number;
Backorder: number;
Manufacturing: number;
Category: string;
ImageSrc: string;
}
const simpleProducts: string[] = [
'HD Video Player',
'SuperHD Video Player',
'SuperPlasma 50',
'SuperLED 50',
'SuperLED 42',
'SuperLCD 55',
'SuperLCD 42',
'SuperPlasma 65',
'SuperLCD 70',
'Projector Plus',
'Projector PlusHT',
'ExcelRemote IR',
'ExcelRemote BT',
'ExcelRemote IP',
];
const products: Product[] = [{
ID: 1,
Name: 'HD Video Player',
Price: 330,
Current_Inventory: 225,
Backorder: 0,
Manufacturing: 10,
Category: 'Video Players',
ImageSrc: '../../../../images/products/1-small.png',
}, {
ID: 2,
Name: 'SuperHD Player',
Price: 400,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 25,
Category: 'Video Players',
ImageSrc: '../../../../images/products/2-small.png',
}, {
ID: 3,
Name: 'SuperPlasma 50',
Price: 2400,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/3-small.png',
}, {
ID: 4,
Name: 'SuperLED 50',
Price: 1600,
Current_Inventory: 77,
Backorder: 0,
Manufacturing: 55,
Category: 'Televisions',
ImageSrc: '../../../../images/products/4-small.png',
}, {
ID: 5,
Name: 'SuperLED 42',
Price: 1450,
Current_Inventory: 445,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/5-small.png',
}, {
ID: 6,
Name: 'SuperLCD 55',
Price: 1350,
Current_Inventory: 345,
Backorder: 0,
Manufacturing: 5,
Category: 'Televisions',
ImageSrc: '../../../../images/products/6-small.png',
}, {
ID: 7,
Name: 'SuperLCD 42',
Price: 1200,
Current_Inventory: 210,
Backorder: 0,
Manufacturing: 20,
Category: 'Televisions',
ImageSrc: '../../../../images/products/7-small.png',
}, {
ID: 8,
Name: 'SuperPlasma 65',
Price: 3500,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/8-small.png',
}, {
ID: 9,
Name: 'SuperLCD 70',
Price: 4000,
Current_Inventory: 95,
Backorder: 0,
Manufacturing: 5,
Category: 'Televisions',
ImageSrc: '../../../../images/products/9-small.png',
}, {
ID: 10,
Name: 'DesktopLED 21',
Price: 175,
Current_Inventory: 0,
Backorder: 425,
Manufacturing: 75,
Category: 'Monitors',
ImageSrc: '../../../../images/products/10-small.png',
}, {
ID: 11,
Name: 'DesktopLED 19',
Price: 165,
Current_Inventory: 425,
Backorder: 0,
Manufacturing: 110,
Category: 'Monitors',
ImageSrc: '../../../../images/products/11-small.png',
}, {
ID: 12,
Name: 'DesktopLCD 21',
Price: 170,
Current_Inventory: 210,
Backorder: 0,
Manufacturing: 60,
Category: 'Monitors',
ImageSrc: '../../../../images/products/12-small.png',
}, {
ID: 13,
Name: 'DesktopLCD 19',
Price: 160,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 210,
Category: 'Monitors',
ImageSrc: '../../../../images/products/13-small.png',
}, {
ID: 14,
Name: 'Projector Plus',
Price: 550,
Current_Inventory: 0,
Backorder: 55,
Manufacturing: 10,
Category: 'Projectors',
ImageSrc: '../../../../images/products/14-small.png',
}, {
ID: 15,
Name: 'Projector PlusHD',
Price: 750,
Current_Inventory: 110,
Backorder: 0,
Manufacturing: 90,
Category: 'Projectors',
ImageSrc: '../../../../images/products/15-small.png',
}, {
ID: 16,
Name: 'Projector PlusHT',
Price: 1050,
Current_Inventory: 0,
Backorder: 75,
Manufacturing: 57,
Category: 'Projectors',
ImageSrc: '../../../../images/products/16-small.png',
}, {
ID: 17,
Name: 'ExcelRemote IR',
Price: 150,
Current_Inventory: 650,
Backorder: 0,
Manufacturing: 190,
Category: 'Automation',
ImageSrc: '../../../../images/products/17-small.png',
}, {
ID: 18,
Name: 'ExcelRemote BT',
Price: 180,
Current_Inventory: 310,
Backorder: 0,
Manufacturing: 0,
Category: 'Automation',
ImageSrc: '../../../../images/products/18-small.png',
}, {
ID: 19,
Name: 'ExcelRemote IP',
Price: 200,
Current_Inventory: 0,
Backorder: 325,
Manufacturing: 225,
Category: 'Automation',
ImageSrc: '../../../../images/products/19-small.png',
}];
@Injectable()
export class Service {
getSimpleProducts(): string[] {
return simpleProducts;
}
getProducts(): Product[] {
return products;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "21.2.17"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
This demo illustrates the following SelectBox properties:
- items
Specifies an array of items displayed in the SelectBox. - placeholder
Specifies the text that is displayed when no items are selected. - readOnly
Prevents users from changing the editor's value via the UI. - disabled
Specifies whether the SelectBox responds to user interaction. - dataSource
Binds the SelectBox to data. Unlike the items property, dataSource accepts the DataSource object that allows users to sort, filter, group, and shape data. - fieldAddons.beforeTemplate and itemTemplate
Allow you to customize the text field and drop-down list items. - onValueChanged event handler
Use this function to perform an action when a user chooses a new value. In this demo, this function is used to display the selected value.
To get started with the DevExtreme SelectBox component, refer to the following tutorial for step-by-step instructions: Getting Started with SelectBox.

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

React Select Box - Overview

The SelectBox component allows users to select an item from a drop-down list.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the SelectBox features used.
Backend API
import React, { useCallback, useState } from 'react'; import SelectBox, { FieldAddons } from 'devextreme-react/select-box'; import type { SelectBoxTypes } from 'devextreme-react/select-box'; import { ArrayStore } from 'devextreme-react/common/data'; import notify from 'devextreme/ui/notify'; import service from './data.ts'; import Field from './Field.tsx'; import Item from './Item.tsx'; const simpleProductLabel = { 'aria-label': 'Simple Product' }; const productIDLabel = { 'aria-label': 'Product ID' }; const productWithPlaceholderLabel = { 'aria-label': 'Product With Placeholder' }; const productLabel = { 'aria-label': 'Product' }; const readOnlyProductLabel = { 'aria-label': 'ReadOnly Product' }; const templatedProductLabel = { 'aria-label': 'Templated Product' }; const disabledProductLabel = { 'aria-label': 'Disabled Product' }; const products = service.getProducts(); const simpleProducts = service.getSimpleProducts(); const data = new ArrayStore({ data: products, key: 'ID', }); function App() { const [value, setValue] = useState(service.getSimpleProducts()[0]); const onValueChanged = useCallback((e: SelectBoxTypes.ValueChangedEvent): void => { setValue(e.value); notify(`The value is changed to: "${e.value}"`); }, []); return ( <div> <div className="dx-fieldset"> <div className="dx-field"> <div className="dx-field-label">Default mode</div> <div className="dx-field-value"> <SelectBox items={simpleProducts} inputAttr={simpleProductLabel} /> </div> </div> <div className="dx-field"> <div className="dx-field-label">With a custom placeholder</div> <div className="dx-field-value"> <SelectBox items={simpleProducts} placeholder="Choose Product" inputAttr={productWithPlaceholderLabel} showClearButton={true} /> </div> </div> <div className="dx-field"> <div className="dx-field-label">Read only</div> <div className="dx-field-value"> <SelectBox items={simpleProducts} defaultValue={simpleProducts[0]} inputAttr={readOnlyProductLabel} readOnly={true} /> </div> </div> <div className="dx-field"> <div className="dx-field-label">Disabled</div> <div className="dx-field-value"> <SelectBox items={simpleProducts} inputAttr={disabledProductLabel} defaultValue={simpleProducts[0]} disabled={true} /> </div> </div> <div className="dx-field"> <div className="dx-field-label">Data source usage</div> <div className="dx-field-value"> <SelectBox dataSource={data} displayExpr="Name" inputAttr={productIDLabel} valueExpr="ID" defaultValue={products[0].ID} /> </div> </div> <div className="dx-field"> <div className="dx-field-label">Custom templates</div> <div className="dx-field-value"> <SelectBox id="custom-templates" dataSource={products} displayExpr="Name" inputAttr={templatedProductLabel} valueExpr="ID" defaultValue={products[3].ID} itemRender={Item} > <FieldAddons beforeRender={Field} /> </SelectBox> </div> </div> </div> <div className="dx-fieldset"> <div className="dx-fieldset-header">Event Handling</div> <div className="dx-field"> <div className="dx-field-label">Product</div> <div className="dx-field-value"> <SelectBox items={simpleProducts} value={value} inputAttr={productLabel} onValueChanged={onValueChanged} /> </div> </div> <div className="current-value"> Selected product is <span>{value}</span> </div> </div> </div> ); } export default App;
import React, { useCallback, useState } from 'react'; import SelectBox, { FieldAddons } from 'devextreme-react/select-box'; import { ArrayStore } from 'devextreme-react/common/data'; import notify from 'devextreme/ui/notify'; import service from './data.js'; import Field from './Field.js'; import Item from './Item.js'; const simpleProductLabel = { 'aria-label': 'Simple Product' }; const productIDLabel = { 'aria-label': 'Product ID' }; const productWithPlaceholderLabel = { 'aria-label': 'Product With Placeholder' }; const productLabel = { 'aria-label': 'Product' }; const readOnlyProductLabel = { 'aria-label': 'ReadOnly Product' }; const templatedProductLabel = { 'aria-label': 'Templated Product' }; const disabledProductLabel = { 'aria-label': 'Disabled Product' }; const products = service.getProducts(); const simpleProducts = service.getSimpleProducts(); const data = new ArrayStore({ data: products, key: 'ID', }); function App() { const [value, setValue] = useState(service.getSimpleProducts()[0]); const onValueChanged = useCallback((e) => { setValue(e.value); notify(`The value is changed to: "${e.value}"`); }, []); return ( <div> <div className="dx-fieldset"> <div className="dx-field"> <div className="dx-field-label">Default mode</div> <div className="dx-field-value"> <SelectBox items={simpleProducts} inputAttr={simpleProductLabel} /> </div> </div> <div className="dx-field"> <div className="dx-field-label">With a custom placeholder</div> <div className="dx-field-value"> <SelectBox items={simpleProducts} placeholder="Choose Product" inputAttr={productWithPlaceholderLabel} showClearButton={true} /> </div> </div> <div className="dx-field"> <div className="dx-field-label">Read only</div> <div className="dx-field-value"> <SelectBox items={simpleProducts} defaultValue={simpleProducts[0]} inputAttr={readOnlyProductLabel} readOnly={true} /> </div> </div> <div className="dx-field"> <div className="dx-field-label">Disabled</div> <div className="dx-field-value"> <SelectBox items={simpleProducts} inputAttr={disabledProductLabel} defaultValue={simpleProducts[0]} disabled={true} /> </div> </div> <div className="dx-field"> <div className="dx-field-label">Data source usage</div> <div className="dx-field-value"> <SelectBox dataSource={data} displayExpr="Name" inputAttr={productIDLabel} valueExpr="ID" defaultValue={products[0].ID} /> </div> </div> <div className="dx-field"> <div className="dx-field-label">Custom templates</div> <div className="dx-field-value"> <SelectBox id="custom-templates" dataSource={products} displayExpr="Name" inputAttr={templatedProductLabel} valueExpr="ID" defaultValue={products[3].ID} itemRender={Item} > <FieldAddons beforeRender={Field} /> </SelectBox> </div> </div> </div> <div className="dx-fieldset"> <div className="dx-fieldset-header">Event Handling</div> <div className="dx-field"> <div className="dx-field-label">Product</div> <div className="dx-field-value"> <SelectBox items={simpleProducts} value={value} inputAttr={productLabel} onValueChanged={onValueChanged} /> </div> </div> <div className="current-value"> Selected product is <span>{value}</span> </div> </div> </div> ); } export default App;
import React from 'react'; export default function Field(data: { ImageSrc: any; Name: any }) { return ( <div className="custom-addon"> <img alt="Product name" src={data?.ImageSrc} /> </div> ); }
import React from 'react'; interface ItemProps { ImageSrc: string; Name: string; } export default function Item(data: ItemProps) { return ( <div className="custom-item"> <img alt="Product name" src={data.ImageSrc} /> <div className="product-name">{data.Name}</div> </div> ); }
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render(<App />, document.getElementById('app'));
const simpleProducts = [ 'HD Video Player', 'SuperHD Video Player', 'SuperPlasma 50', 'SuperLED 50', 'SuperLED 42', 'SuperLCD 55', 'SuperLCD 42', 'SuperPlasma 65', 'SuperLCD 70', 'Projector Plus', 'Projector PlusHT', 'ExcelRemote IR', 'ExcelRemote BT', 'ExcelRemote IP', ]; const products = [{ ID: 1, Name: 'HD Video Player', Price: 330, Current_Inventory: 225, Backorder: 0, Manufacturing: 10, Category: 'Video Players', ImageSrc: '../../../../images/products/1-small.png', }, { ID: 2, Name: 'SuperHD Player', Price: 400, Current_Inventory: 150, Backorder: 0, Manufacturing: 25, Category: 'Video Players', ImageSrc: '../../../../images/products/2-small.png', }, { ID: 3, Name: 'SuperPlasma 50', Price: 2400, Current_Inventory: 0, Backorder: 0, Manufacturing: 0, Category: 'Televisions', ImageSrc: '../../../../images/products/3-small.png', }, { ID: 4, Name: 'SuperLED 50', Price: 1600, Current_Inventory: 77, Backorder: 0, Manufacturing: 55, Category: 'Televisions', ImageSrc: '../../../../images/products/4-small.png', }, { ID: 5, Name: 'SuperLED 42', Price: 1450, Current_Inventory: 445, Backorder: 0, Manufacturing: 0, Category: 'Televisions', ImageSrc: '../../../../images/products/5-small.png', }, { ID: 6, Name: 'SuperLCD 55', Price: 1350, Current_Inventory: 345, Backorder: 0, Manufacturing: 5, Category: 'Televisions', ImageSrc: '../../../../images/products/6-small.png', }, { ID: 7, Name: 'SuperLCD 42', Price: 1200, Current_Inventory: 210, Backorder: 0, Manufacturing: 20, Category: 'Televisions', ImageSrc: '../../../../images/products/7-small.png', }, { ID: 8, Name: 'SuperPlasma 65', Price: 3500, Current_Inventory: 0, Backorder: 0, Manufacturing: 0, Category: 'Televisions', ImageSrc: '../../../../images/products/8-small.png', }, { ID: 9, Name: 'SuperLCD 70', Price: 4000, Current_Inventory: 95, Backorder: 0, Manufacturing: 5, Category: 'Televisions', ImageSrc: '../../../../images/products/9-small.png', }, { ID: 10, Name: 'DesktopLED 21', Price: 175, Current_Inventory: 0, Backorder: 425, Manufacturing: 75, Category: 'Monitors', ImageSrc: '../../../../images/products/10-small.png', }, { ID: 11, Name: 'DesktopLED 19', Price: 165, Current_Inventory: 425, Backorder: 0, Manufacturing: 110, Category: 'Monitors', ImageSrc: '../../../../images/products/11-small.png', }, { ID: 12, Name: 'DesktopLCD 21', Price: 170, Current_Inventory: 210, Backorder: 0, Manufacturing: 60, Category: 'Monitors', ImageSrc: '../../../../images/products/12-small.png', }, { ID: 13, Name: 'DesktopLCD 19', Price: 160, Current_Inventory: 150, Backorder: 0, Manufacturing: 210, Category: 'Monitors', ImageSrc: '../../../../images/products/13-small.png', }, { ID: 14, Name: 'Projector Plus', Price: 550, Current_Inventory: 0, Backorder: 55, Manufacturing: 10, Category: 'Projectors', ImageSrc: '../../../../images/products/14-small.png', }, { ID: 15, Name: 'Projector PlusHD', Price: 750, Current_Inventory: 110, Backorder: 0, Manufacturing: 90, Category: 'Projectors', ImageSrc: '../../../../images/products/15-small.png', }, { ID: 16, Name: 'Projector PlusHT', Price: 1050, Current_Inventory: 0, Backorder: 75, Manufacturing: 57, Category: 'Projectors', ImageSrc: '../../../../images/products/16-small.png', }, { ID: 17, Name: 'ExcelRemote IR', Price: 150, Current_Inventory: 650, Backorder: 0, Manufacturing: 190, Category: 'Automation', ImageSrc: '../../../../images/products/17-small.png', }, { ID: 18, Name: 'ExcelRemote BT', Price: 180, Current_Inventory: 310, Backorder: 0, Manufacturing: 0, Category: 'Automation', ImageSrc: '../../../../images/products/18-small.png', }, { ID: 19, Name: 'ExcelRemote IP', Price: 200, Current_Inventory: 0, Backorder: 325, Manufacturing: 225, Category: 'Automation', ImageSrc: '../../../../images/products/19-small.png', }]; export default { getSimpleProducts() { return simpleProducts; }, getProducts() { return products; }, };
window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, jsx: 'react', }, meta: { 'react': { 'esModule': true, }, 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, }, paths: { 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, defaultExtension: 'js', map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs', 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme-react/common': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: 'json', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" } };
import React from 'react'; export default function Field(data) { return ( <div className="custom-addon"> <img alt="Product name" src={data?.ImageSrc} /> </div> ); }
import React from 'react'; export default function Item(data) { return ( <div className="custom-item"> <img alt="Product name" src={data.ImageSrc} /> <div className="product-name">{data.Name}</div> </div> ); }
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
const simpleProducts = [ 'HD Video Player', 'SuperHD Video Player', 'SuperPlasma 50', 'SuperLED 50', 'SuperLED 42', 'SuperLCD 55', 'SuperLCD 42', 'SuperPlasma 65', 'SuperLCD 70', 'Projector Plus', 'Projector PlusHT', 'ExcelRemote IR', 'ExcelRemote BT', 'ExcelRemote IP', ]; const products = [ { ID: 1, Name: 'HD Video Player', Price: 330, Current_Inventory: 225, Backorder: 0, Manufacturing: 10, Category: 'Video Players', ImageSrc: '../../../../images/products/1-small.png', }, { ID: 2, Name: 'SuperHD Player', Price: 400, Current_Inventory: 150, Backorder: 0, Manufacturing: 25, Category: 'Video Players', ImageSrc: '../../../../images/products/2-small.png', }, { ID: 3, Name: 'SuperPlasma 50', Price: 2400, Current_Inventory: 0, Backorder: 0, Manufacturing: 0, Category: 'Televisions', ImageSrc: '../../../../images/products/3-small.png', }, { ID: 4, Name: 'SuperLED 50', Price: 1600, Current_Inventory: 77, Backorder: 0, Manufacturing: 55, Category: 'Televisions', ImageSrc: '../../../../images/products/4-small.png', }, { ID: 5, Name: 'SuperLED 42', Price: 1450, Current_Inventory: 445, Backorder: 0, Manufacturing: 0, Category: 'Televisions', ImageSrc: '../../../../images/products/5-small.png', }, { ID: 6, Name: 'SuperLCD 55', Price: 1350, Current_Inventory: 345, Backorder: 0, Manufacturing: 5, Category: 'Televisions', ImageSrc: '../../../../images/products/6-small.png', }, { ID: 7, Name: 'SuperLCD 42', Price: 1200, Current_Inventory: 210, Backorder: 0, Manufacturing: 20, Category: 'Televisions', ImageSrc: '../../../../images/products/7-small.png', }, { ID: 8, Name: 'SuperPlasma 65', Price: 3500, Current_Inventory: 0, Backorder: 0, Manufacturing: 0, Category: 'Televisions', ImageSrc: '../../../../images/products/8-small.png', }, { ID: 9, Name: 'SuperLCD 70', Price: 4000, Current_Inventory: 95, Backorder: 0, Manufacturing: 5, Category: 'Televisions', ImageSrc: '../../../../images/products/9-small.png', }, { ID: 10, Name: 'DesktopLED 21', Price: 175, Current_Inventory: 0, Backorder: 425, Manufacturing: 75, Category: 'Monitors', ImageSrc: '../../../../images/products/10-small.png', }, { ID: 11, Name: 'DesktopLED 19', Price: 165, Current_Inventory: 425, Backorder: 0, Manufacturing: 110, Category: 'Monitors', ImageSrc: '../../../../images/products/11-small.png', }, { ID: 12, Name: 'DesktopLCD 21', Price: 170, Current_Inventory: 210, Backorder: 0, Manufacturing: 60, Category: 'Monitors', ImageSrc: '../../../../images/products/12-small.png', }, { ID: 13, Name: 'DesktopLCD 19', Price: 160, Current_Inventory: 150, Backorder: 0, Manufacturing: 210, Category: 'Monitors', ImageSrc: '../../../../images/products/13-small.png', }, { ID: 14, Name: 'Projector Plus', Price: 550, Current_Inventory: 0, Backorder: 55, Manufacturing: 10, Category: 'Projectors', ImageSrc: '../../../../images/products/14-small.png', }, { ID: 15, Name: 'Projector PlusHD', Price: 750, Current_Inventory: 110, Backorder: 0, Manufacturing: 90, Category: 'Projectors', ImageSrc: '../../../../images/products/15-small.png', }, { ID: 16, Name: 'Projector PlusHT', Price: 1050, Current_Inventory: 0, Backorder: 75, Manufacturing: 57, Category: 'Projectors', ImageSrc: '../../../../images/products/16-small.png', }, { ID: 17, Name: 'ExcelRemote IR', Price: 150, Current_Inventory: 650, Backorder: 0, Manufacturing: 190, Category: 'Automation', ImageSrc: '../../../../images/products/17-small.png', }, { ID: 18, Name: 'ExcelRemote BT', Price: 180, Current_Inventory: 310, Backorder: 0, Manufacturing: 0, Category: 'Automation', ImageSrc: '../../../../images/products/18-small.png', }, { ID: 19, Name: 'ExcelRemote IP', Price: 200, Current_Inventory: 0, Backorder: 325, Manufacturing: 225, Category: 'Automation', ImageSrc: '../../../../images/products/19-small.png', }, ]; export default { getSimpleProducts() { return simpleProducts; }, getProducts() { return products; }, };
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
/* stylelint-disable indentation */ /* stylelint-disable selector-descendant-combinator-no-non-space */ .dx-dropdownlist-popup-wrapper .dx-list:not(.dx-list-select-decorator-enabled) .dx-list-item-content { padding-left: 7px; padding-right: 7px; } .custom-item { position: relative; min-height: 30px; } .custom-addon { padding-left: 8px; display: flex; align-items: center; } .dx-dropdowneditor-input-wrapper .custom-item > img { padding-left: 8px; } .custom-item .product-name { display: inline-block; padding-left: 50px; text-indent: 0; line-height: 30px; font-size: 15px; width: 100%; } .custom-item > img { left: 1px; position: absolute; top: 50%; margin-top: -15px; } .dx-theme-material #custom-templates .dx-texteditor-buttons-container { display: none; } .current-value { padding: 10px 0; } .current-value > span { font-weight: bold; } .dx-theme-material .dx-selectbox-container .product-name { padding-left: 58px; }

This demo illustrates the following SelectBox properties:

  • items
    Specifies an array of items displayed in the SelectBox.
  • placeholder
    Specifies the text that is displayed when no items are selected.
  • readOnly
    Prevents users from changing the editor's value via the UI.
  • disabled
    Specifies whether the SelectBox responds to user interaction.
  • dataSource
    Binds the SelectBox to data. Unlike the items property, dataSource accepts the DataSource object that allows users to sort, filter, group, and shape data.
  • fieldAddons.beforeRender and itemRender
    Allow you to customize the text field and drop-down list items.
  • onValueChanged event handler
    Use this function to perform an action when a user chooses a new value. In this demo, this function is used to display the selected value.

To get started with the DevExtreme SelectBox component, refer to the following tutorial for step-by-step instructions: Getting Started with SelectBox.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the SelectBox features used.
Backend API
<template>
<div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Default mode</div>
<div class="dx-field-value">
<DxSelectBox
:items="simpleProducts"
:input-attr="{ 'aria-label': 'Simple Product' }"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">With a custom placeholder</div>
<div class="dx-field-value">
<DxSelectBox
:items="simpleProducts"
:input-attr="{ 'aria-label': 'Product With Placeholder' }"
:show-clear-button="true"
placeholder="Choose Product"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Read only</div>
<div class="dx-field-value">
<DxSelectBox
:items="simpleProducts"
:input-attr="{ 'aria-label': 'ReadOnly Product' }"
:value="simpleProducts[0]"
:read-only="true"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Disabled</div>
<div class="dx-field-value">
<DxSelectBox
:items="simpleProducts"
:input-attr="{ 'aria-label': 'Disabled Product' }"
:value="simpleProducts[0]"
:disabled="true"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Data source usage</div>
<div class="dx-field-value">
<DxSelectBox
:data-source="data"
:input-attr="{ 'aria-label': 'Product ID' }"
:value="products[0].ID"
display-expr="Name"
value-expr="ID"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Custom templates</div>
<div class="dx-field-value">
<DxSelectBox
id="custom-templates"
:data-source="products"
:value="products[3].ID"
:input-attr="{ 'aria-label': 'Templated Product' }"
display-expr="Name"
value-expr="ID"
:field-addons="{ beforeTemplate: 'before' }"
item-template="item"
>
<template #before="{ data }">
<Field :field-data="data"/>
</template>
<template #item="{ data }">
<Item :item-data="data"/>
</template>
</DxSelectBox>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Event Handling</div>
<div class="dx-field">
<div class="dx-field-label">Product</div>
<div class="dx-field-value">
<DxSelectBox
:items="simpleProducts"
:input-attr="{ 'aria-label': 'Product' }"
v-model:value="value"
@value-changed="onValueChanged"
/>
</div>
</div>
<div class="current-value">
Selected product is <span>{{ value }}</span>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxSelectBox, { type DxSelectBoxTypes } from 'devextreme-vue/select-box';
import { ArrayStore } from 'devextreme-vue/common/data';
import notify from 'devextreme/ui/notify';
import Field from './Field.vue';
import Item from './Item.vue';
import service from './data.ts';
const products = service.getProducts();
const simpleProducts = service.getSimpleProducts();
const value = ref(simpleProducts[0]);
const data = new ArrayStore({
data: products,
key: 'ID',
});
function onValueChanged(e: DxSelectBoxTypes.ValueChangedEvent) {
notify(`The value is changed to: "${e.value}"`);
}
</script>
<style scoped>
.dx-dropdownlist-popup-wrapper .dx-list:not(.dx-list-select-decorator-enabled) .dx-list-item-content {
padding-left: 7px;
padding-right: 7px;
}
.custom-item {
position: relative;
min-height: 30px;
}
.custom-addon {
padding-left: 8px;
display: flex;
align-items: center;
}
.dx-dropdowneditor-input-wrapper .custom-item > img {
padding-left: 8px;
}
.custom-item .product-name {
display: inline-block;
padding-left: 50px;
text-indent: 0;
line-height: 30px;
font-size: 15px;
width: 100%;
}
.custom-item > img {
left: 1px;
position: absolute;
top: 50%;
margin-top: -15px;
}
.dx-theme-material #custom-templates .dx-texteditor-buttons-container {
display: none;
}
.current-value {
padding: 10px 0;
}
.current-value > span {
font-weight: bold;
}
.dx-theme-material .dx-selectbox-container .product-name {
padding-left: 58px;
}
</style>
<template>
<div class="custom-addon">
<img
v-if="fieldData"
alt="Product name"
:src="fieldData.ImageSrc"
>
</div>
</template>
<script setup lang="ts">
import DxTextBox from 'devextreme-vue/text-box';
withDefaults(defineProps<{
fieldData?: Record<string, any>
}>(), {
fieldData: () => ({} as Record<string, any>),
});
</script>
<template>
<div class="custom-item">
<img
alt="Product name"
:src="itemData.ImageSrc"
>
<div class="product-name">
{{ itemData.Name }}
</div>
</div>
</template>
<script setup lang="ts">
withDefaults(defineProps<{
itemData?: Record<string, any>
}>(), {
itemData: () => ({} as Record<string, any>),
});
</script>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
const simpleProducts = [
'HD Video Player',
'SuperHD Video Player',
'SuperPlasma 50',
'SuperLED 50',
'SuperLED 42',
'SuperLCD 55',
'SuperLCD 42',
'SuperPlasma 65',
'SuperLCD 70',
'Projector Plus',
'Projector PlusHT',
'ExcelRemote IR',
'ExcelRemote BT',
'ExcelRemote IP',
];
const products = [{
ID: 1,
Name: 'HD Video Player',
Price: 330,
Current_Inventory: 225,
Backorder: 0,
Manufacturing: 10,
Category: 'Video Players',
ImageSrc: '../../../../images/products/1-small.png',
}, {
ID: 2,
Name: 'SuperHD Player',
Price: 400,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 25,
Category: 'Video Players',
ImageSrc: '../../../../images/products/2-small.png',
}, {
ID: 3,
Name: 'SuperPlasma 50',
Price: 2400,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/3-small.png',
}, {
ID: 4,
Name: 'SuperLED 50',
Price: 1600,
Current_Inventory: 77,
Backorder: 0,
Manufacturing: 55,
Category: 'Televisions',
ImageSrc: '../../../../images/products/4-small.png',
}, {
ID: 5,
Name: 'SuperLED 42',
Price: 1450,
Current_Inventory: 445,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/5-small.png',
}, {
ID: 6,
Name: 'SuperLCD 55',
Price: 1350,
Current_Inventory: 345,
Backorder: 0,
Manufacturing: 5,
Category: 'Televisions',
ImageSrc: '../../../../images/products/6-small.png',
}, {
ID: 7,
Name: 'SuperLCD 42',
Price: 1200,
Current_Inventory: 210,
Backorder: 0,
Manufacturing: 20,
Category: 'Televisions',
ImageSrc: '../../../../images/products/7-small.png',
}, {
ID: 8,
Name: 'SuperPlasma 65',
Price: 3500,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/8-small.png',
}, {
ID: 9,
Name: 'SuperLCD 70',
Price: 4000,
Current_Inventory: 95,
Backorder: 0,
Manufacturing: 5,
Category: 'Televisions',
ImageSrc: '../../../../images/products/9-small.png',
}, {
ID: 10,
Name: 'DesktopLED 21',
Price: 175,
Current_Inventory: 0,
Backorder: 425,
Manufacturing: 75,
Category: 'Monitors',
ImageSrc: '../../../../images/products/10-small.png',
}, {
ID: 11,
Name: 'DesktopLED 19',
Price: 165,
Current_Inventory: 425,
Backorder: 0,
Manufacturing: 110,
Category: 'Monitors',
ImageSrc: '../../../../images/products/11-small.png',
}, {
ID: 12,
Name: 'DesktopLCD 21',
Price: 170,
Current_Inventory: 210,
Backorder: 0,
Manufacturing: 60,
Category: 'Monitors',
ImageSrc: '../../../../images/products/12-small.png',
}, {
ID: 13,
Name: 'DesktopLCD 19',
Price: 160,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 210,
Category: 'Monitors',
ImageSrc: '../../../../images/products/13-small.png',
}, {
ID: 14,
Name: 'Projector Plus',
Price: 550,
Current_Inventory: 0,
Backorder: 55,
Manufacturing: 10,
Category: 'Projectors',
ImageSrc: '../../../../images/products/14-small.png',
}, {
ID: 15,
Name: 'Projector PlusHD',
Price: 750,
Current_Inventory: 110,
Backorder: 0,
Manufacturing: 90,
Category: 'Projectors',
ImageSrc: '../../../../images/products/15-small.png',
}, {
ID: 16,
Name: 'Projector PlusHT',
Price: 1050,
Current_Inventory: 0,
Backorder: 75,
Manufacturing: 57,
Category: 'Projectors',
ImageSrc: '../../../../images/products/16-small.png',
}, {
ID: 17,
Name: 'ExcelRemote IR',
Price: 150,
Current_Inventory: 650,
Backorder: 0,
Manufacturing: 190,
Category: 'Automation',
ImageSrc: '../../../../images/products/17-small.png',
}, {
ID: 18,
Name: 'ExcelRemote BT',
Price: 180,
Current_Inventory: 310,
Backorder: 0,
Manufacturing: 0,
Category: 'Automation',
ImageSrc: '../../../../images/products/18-small.png',
}, {
ID: 19,
Name: 'ExcelRemote IP',
Price: 200,
Current_Inventory: 0,
Backorder: 325,
Manufacturing: 225,
Category: 'Automation',
ImageSrc: '../../../../images/products/19-small.png',
}];
export default {
getSimpleProducts() {
return simpleProducts;
},
getProducts() {
return products;
},
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
This demo illustrates the following SelectBox properties:
- items
Specifies an array of items displayed in the SelectBox. - placeholder
Specifies the text that is displayed when no items are selected. - readOnly
Prevents users from changing the editor's value via the UI. - disabled
Specifies whether the SelectBox responds to user interaction. - dataSource
Binds the SelectBox to data. Unlike the items property, dataSource accepts the DataSource object that allows users to sort, filter, group, and shape data. - fieldAddons.beforeTemplate and itemTemplate
Allow you to customize the text field and drop-down list items. - onValueChanged event handler
Use this function to perform an action when a user chooses a new value. In this demo, this function is used to display the selected value.
To get started with the DevExtreme SelectBox component, refer to the following tutorial for step-by-step instructions: Getting Started with SelectBox.